package org.foxarmy.barcodescannerforemployees.fragments

import android.os.Bundle
import android.provider.BaseColumns
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.LinearLayout
import androidx.fragment.app.Fragment
import org.foxarmy.barcodescannerforemployees.CategoriesContract
import org.foxarmy.barcodescannerforemployees.Category
import org.foxarmy.barcodescannerforemployees.DBStorageController
import org.foxarmy.barcodescannerforemployees.R
import org.foxarmy.barcodescannerforemployees.views.CategoryView

class CategoriesFragment : Fragment() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
    }

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {
        // Inflate the layout for this fragment
        return inflater.inflate(R.layout.fragment_categories, container, false)
    }

    override fun onResume() {
        super.onResume()

        updateContent()
    }

    fun updateContent() {
        val layout = view?.findViewById<LinearLayout>(R.id.categoriesLayout)
        layout?.removeAllViews()

        val db = DBStorageController(requireContext()).readableDatabase

        val projection = arrayOf(
            BaseColumns._ID,
            CategoriesContract.CategoryEntry.CATEGORY_NAME
        )

        val cursor = db.query(CategoriesContract.CategoryEntry.TABLE_NAME, projection, null, null, null, null, null)

        with (cursor) {
            while(moveToNext()) {
                val categoryId = getInt(getColumnIndexOrThrow(BaseColumns._ID))
                val categoryName = getString(getColumnIndexOrThrow(CategoriesContract.CategoryEntry.CATEGORY_NAME))

                val category = Category(categoryId, categoryName)

                val categoryView = CategoryView(requireActivity(), requireContext(), category)
                layout?.addView(categoryView)
            }
        }
    }
//    public fun updateContent() {
//
//        val grv = getView()?.findViewById<GridLayout>(R.id.contentGridLayout)
//        grv?.removeAllViews()
//
//        val db = DBStorageController(requireContext()).readableDatabase
//        val projection = arrayOf(
//            BaseColumns._ID,
//            ProductContract.ProductEntry.PRODUCT_NAME,
//            ProductContract.ProductEntry.PRODUCT_NET_WEIGHT,
//            ProductContract.ProductEntry.IMAGE_FILENAME
//        )
//
//        val cursor = db.query(ProductContract.ProductEntry.TABLE_NAME, projection, null, null, null, null, null)
//
//        with (cursor) {
//            while(moveToNext()) {
//                val productId = getInt(getColumnIndexOrThrow(BaseColumns._ID))
//                val productName = getString(getColumnIndexOrThrow(ProductContract.ProductEntry.PRODUCT_NAME))
//                val netWeight = getDouble(getColumnIndexOrThrow(ProductContract.ProductEntry.PRODUCT_NET_WEIGHT))
//                val productImageHash = getString(getColumnIndexOrThrow(ProductContract.ProductEntry.IMAGE_FILENAME))
//
//                val product = AbstractProduct(productId, productName, netWeight, productImageHash, 1)
//
//                generateThumbnailForImage(context!!, productImageHash)
//
//                val abstractProduct = AbstractProductView(
//                    requireActivity(),
//                    requireContext(),
//                    product
//                )
//                grv?.addView(abstractProduct)
//            }
//        }
//    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        updateContent()
    }
}